/*********************************************
* Object Orientated Example Using Base Class *
* Author: Andreas Oberdorfer            2004 *
*********************************************/

#ifndef __EXAMPLE_H__
#define __EXAMPLE_H__

#include "HPTime.h"
#include "vector.h"

#include <list>
#include <vector>
using namespace std;

#include "NeHeGL.h"												// Header File For NeHeGL


class GL_Example : GL_Application								// Derive From Application
{
public:
	bool	Initialize();										// Perform All Initialization
	void	Deinitialize();										// Perform All DeInitialization
	void	Update(DWORD milliseconds);							// Perform Motion Updates
	void	Draw();												// Perform All Scene Drawing

	void BuildFont(void);
	void KillFont(void);
	void glPrint(bool,const char *);

private:

	GLuint	base;
	GLYPHMETRICSFLOAT gmf[256];	// Storage For Information About Our Outline Font Characters

	friend class GL_Application;
	GL_Example(const char * class_name);						// Class Constructor

	float	m_Angle;											// Used To Rotate The Triangles

	long m_lPoincareEntries;
	list <Vector> m_LVPoincare;
	long m_lEPhasenRaumEntries;
	list <Vector> m_LVEPhasenRaum;

	double m_dt;
	double m_fq;
	double m_fg;
	double m_fwd;
	double m_fTheta;
	double m_fThetap;
	double m_fPoincareLevel;
};


#endif	// __EXAMPLE_H__
